Codeforces Round #136 (Div. 1) C. Little Elephant and Shifts

2023-11-07 04:58

本文主要是介绍Codeforces Round #136 (Div. 1) C. Little Elephant and Shifts,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目链接:

http://codeforces.com/problemset/problem/220/C

C. Little Elephant and Shifts

 

The Little Elephant has two permutations a and b of length n, consisting of numbers from 1 to n, inclusive. Let's denote the i-th (1 ≤ i ≤ n) element of the permutation a as ai, the j-th (1 ≤ j ≤ n) element of the permutation b — as bj.

The distance between permutations a and b is the minimum absolute value of the difference between the positions of the occurrences of some number in a and in b. More formally, it's such minimum |i - j|, that ai = bj.

A cyclic shift number i (1 ≤ i ≤ n) of permutation b consisting from n elements is a permutation bibi + 1... bnb1b2... bi - 1. Overall a permutation has n cyclic shifts.

The Little Elephant wonders, for all cyclic shifts of permutation b, what is the distance between the cyclic shift and permutation a?

Input

The first line contains a single integer n (1 ≤ n ≤ 105) — the size of the permutations. The second line contains permutation a as ndistinct numbers from 1 to n, inclusive. The numbers are separated with single spaces. The third line contains permutation b in the same format.

Output

In n lines print n integers — the answers for cyclic shifts. Print the answers to the shifts in the order of the shifts' numeration in permutation b, that is, first for the 1-st cyclic shift, then for the 2-nd, and so on.

Examples

input

Copy

2
1 2
2 1

output

Copy

1
0

input

Copy

4
2 1 3 4
3 4 2 1

output

Copy

2
1
0
1

 

题意:
给你一个a数组,一个b数组,都只含1-n,俩数组的距离定义为,if(a[i]==b[j])dis=min(dis,abs(j-i)),然后对于每一个b向左循环移动的排列,让你输出距离。

分析:
若b[j]在a[i]的左边,随着每次左移,两点间dis+1
若b[j]在a[i]的右边,随着每次左移,两点间dis-1


每次的答案,从>=0的里面找最小的,<0的里面找最大的,两者再取最小

对于如何模拟,举一个例子。

4

2 1 3 4

3 4 2 1


1.  将距离(b[i]-a[i])存入muliset里面:-2 -2 2 2

     我们知道要找绝对值最小值,即找最接近0的,然后即s.lower_bound(0)  ans=min(0-(-2),2-0)

     我们更新距离要这么更新,首先删除b首个元素的距离,把他放在最后。
  

a[]

2134
移动后的b[]4213
multiset里面存的数据-2222

2.
muliset里面现在为:-2 2 2 2,找最小值的话,我们应该找最接近1的,因为

对于两个数组,我们知道元素位置相差1才能是对应想等的

ans=min(1-(-2),2-1)   ,因为我们在muliset实际情况没有减1,所以对于1左边的加一个1,1右边的减一个1.

其他步对应同理

This is the code:

#include<algorithm>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<cstdlib>
#include<iostream>
#include<iomanip>
#include<list>
#include<map>
#include<queue>
#include<sstream>
#include<stack>
#include<string>
#include<set>
#include<vector>
using namespace std;
#define PI acos(-1.0)
#define pppp cout<<endl;
#define EPS 1e-8
#define LL long long
#define ULL unsigned long long     //1844674407370955161
#define INT_INF 0x3f3f3f3f      //1061109567
#define LL_INF 0x3f3f3f3f3f3f3f3f //4557430888798830399
// ios::sync_with_stdio(false);
// 那么cin, 就不能跟C的 scanf,sscanf, getchar, fgets之类的一起使用了。
const int dr[]={0, 0, -1, 1, -1, -1, 1, 1};
const int dc[]={-1, 1, 0, 0, -1, 1, -1, 1};
int read()//输入外挂
{int ret=0, flag=0;char ch;if((ch=getchar())=='-')flag=1;else if(ch>='0'&&ch<='9')ret = ch - '0';while((ch=getchar())>='0'&&ch<='9')ret=ret*10+(ch-'0');return flag ? -ret : ret;
}
const int maxn=100005;
int a[maxn];
int b[maxn];
multiset<int> ms;
multiset<int>::iterator msit;
int main()
{int n,x;scanf("%d",&n);for(int i=0; i<n; ++i)//注意循环对应{scanf("%d",&x);a[x]=i;}for(int i=0;i<n;++i)//注意和下边的那个循环对应起来{scanf("%d",&b[i]);ms.insert(i-a[b[i]]);//将b[j]和a[i]的距离存储起来,大于零表示b[j]在a[i]的右边,反之在左边}for(int i=0; i<n; ++i)//表示没有移动前差为多少,即表示时间戳,表示移动了几次{msit=ms.lower_bound(i);//找到正好差值为i的第一个int ans=INT_INF;if(msit!=ms.end())ans=min(ans,*msit-i);if(msit!=ms.begin())ans=min(ans,i-*(--msit));//找到差值的比i小的第一个printf("%d\n",ans);msit=ms.find(i-a[b[i]]); //找到当前最左边的那一个删除掉,然后添加在右边ms.erase(msit);ms.insert(i-a[b[i]]+n);//添加在右边相当于加了n}}

 

这篇关于Codeforces Round #136 (Div. 1) C. Little Elephant and Shifts的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/361390

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There